<?php
/*
 * Copyright (C) 2007-2008, M2X
 *
 * Authors: Jean-Paul Saman
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 *****************************************************************************/
if (!defined('W2P_BASE_DIR')) {
    die('You should not access this file directly.');
}

function getMonthByName($month)
{
    if ($month == 1)
        $name = w2PformSafe('January');
    else if ($month == 2)
        $name = w2PformSafe('February');
    else if ($month == 3)
        $name = w2PformSafe('March');
    else if ($month == 4)
        $name = w2PformSafe('April');
    else if ($month == 5)
        $name = w2PformSafe('May');
    else if ($month == 6)
        $name = w2PformSafe('June');
    else if ($month == 7)
        $name = w2PformSafe('July');
    else if ($month == 8)
        $name = w2PformSafe('August');
    else if ($month == 9)
        $name = w2PformSafe('September');
    else if ($month == 10)
        $name = w2PformSafe('October');
   else if ($month == 11)
        $name = w2PformSafe('November');
    else if ($month == 12)
        $name = w2PformSafe('December');
    return $name;
}

function printTableHeader()
{
    GLOBAL $AppUI;

    //prepare an html table with a head section
    echo "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\" class=\"tbl\">";
    echo "<tr>";
    echo "<th nowrap=\"nowrap\">&nbsp;</th>";
    echo "<th nowrap=\"nowrap\">".$AppUI->_( 'Date' )."</th>";
    echo "<th nowrap=\"nowrap\">".$AppUI->_( 'Period' )."</th>";
    echo "<th nowrap=\"nowrap\">".$AppUI->_( 'Year' )."</th>";
    echo "<th nowrap=\"nowrap\">".$AppUI->_( 'Worked' )."</th>";
    echo "<th nowrap=\"nowrap\">".$AppUI->_( 'Submitter' )."</th>";
    echo "<th nowrap=\"nowrap\">".$AppUI->_( 'Status' )."</th>";
    echo "<th nowrap=\"nowrap\">&nbsp;</th>";
    echo "</tr>";
}

function timesheets($type, $order)
{
    GLOBAL $AppUI, $canRead, $canEdit, $canDelete;

    // FIXME: lock out users that do not have at least readPermission on this module
    if (!$canRead) {
        $AppUI->redirect( "m=public&a=access_denied" );
    }

    printTableHeader();

    // FIXME: Retrieve the list of users that may access this module.
    if(isset($_REQUEST["user_filter_id"])){
        $AppUI->setState("user_filter_id", $_REQUEST["user_filter_id"]);
        $user_filter_id = $_REQUEST["user_filter_id"];
    } else {
        $user_filter_id = $AppUI->getState('user_filter_id');
        if (!isset($user_filter_id)) {
            $user_filter_id = $AppUI->user_id;
            $AppUI->setState('user_filter_id', $user_filter_id);
        }
    }

    $perms =& $AppUI->acl();
    if ($canDelete) {
        $user_list = array( 0 => $AppUI->_("All", UI_OUTPUT_RAW)) + $perms->getPermittedUsers("timesheet");
    } else {
        $user_list = array( ) + $perms->getPermittedUsers("timesheet");
    }
    $user_combo = arraySelect($user_list, "user_filter_id", "class='text' onchange='javascript:document.searchform.submit()'", $user_filter_id, false);

    echo "<tr><form name='searchform' action='?m=timesheet' method='post'>
         ".$AppUI->_("Show timesheets for ").": $user_combo </form></tr>";

    // Pull all users
    $q = new w2p_Database_Query();
    $q->addQuery('user_id, contact_first_name, contact_last_name');
    $q->addTable('users');
    $q->addTable('contacts');
    $q->addWhere('user_contact = contact_id');
    $q->addOrder('contact_last_name, contact_first_name');
    if (!$q->exec()) {
        db_error();
    }
    $users = array();
    while ( $row = $q->fetchRow()) {
        $users[$row['user_id']] = $row['contact_last_name'] . ', ' . $row['contact_first_name'];
    }

    $q->Clear();
    $q->addQuery('timesheet_id, timesheet_date, timesheet_status, timesheet_period, timesheet_creator, timesheet_worked');
    $q->addTable('timesheet');
    if ($user_filter_id > 0) {
        $q->addWhere('timesheet_creator = ' . $user_filter_id );
    } else {
        $q->addOrder('timesheet_creator');
    }
    if ($sort == "Ascending")
        $q->addOrder('timesheet_period ' . $order); 
    else
        $q->addOrder('timesheet_period ' . $order);

    if ($type >= 0)
        $q->addWhere('timesheet_status = '. $type );
    $month = $q->loadList();

    // add/show now gradually the timesheet
    foreach ($month as $row) {
        echo "<tr>";
        echo "<td nowrap=\"nowrap\" width=\"20\">";
            if (($canEdit) && ($row["timesheet_status"]) < 1) {
                // call the edit site with the unique id of the timesheet item
                echo "\n".'<a href="?m=timesheet&a=addedit&timesheet_id=' . $row["timesheet_id"] . '">';
                echo w2PshowImage( 'icons/stock_edit-16.png', '16', '16' );
                echo "\n</a>";
            }
        echo "</td>";
        echo "<td>";
            $date = new w2p_Utilities_Date();
            $date->setDate($row["timesheet_date"],DATE_FORMAT_UNIXTIME);
            echo '<a href="?m=timesheet&a=addedit&timesheet_id=' . $row["timesheet_id"] . '">';
            echo $date->format( FMT_TIMESTAMP_DATE );
            echo "</a>";
        echo "</td>";
        echo "<td>";
        echo "\n".'<a href="?m=timesheet&a=addedit&timesheet_id=' . $row["timesheet_id"] . '">';
            $period = new w2p_Utilities_Date();
            if (intval($row["timesheet_period"])<=12) { // << hack for previouse timesheet versions
                $period->setMonth($row["timesheet_period"]);
                $period->setYear(2007);
            }
            else
                $period->setDate($row["timesheet_period"],DATE_FORMAT_UNIXTIME);
// /*debug >>*/echo "(". $row["timesheet_period"] . "," . $period->getMonth() . ") " ; //<< debug
            echo getMonthByName($period->getMonth()) . " " . $period->getYear();
            echo "\n</a>";
        echo "</td>";
        echo "<td>". $period->getYear() ."</td>";
        echo "<td>". $row["timesheet_worked"] ."</td>";
        echo "<td>". $users[$row["timesheet_creator"]] ."</td>";
        echo "<td>";
            $status = $row["timesheet_status"];
            if ($status == 0)
                echo w2PformSafe("Open for Editing");
            else if ($status == 1)
                echo w2PformSafe("Submitted"); // closed for normal users
            else if ($status == 2)
                echo w2PformSafe("Approved");
        echo "</td>";
        echo "<td nowrap=\"nowrap\" width=\"20\">";
            if ($canDelete) {
                // call the edit site with the unique id of the timesheet item
                echo "\n".'<a href="?m=timesheet&a=addedit&timesheet_id=' . $row["timesheet_id"] . '">';
                echo w2PshowImage( 'icons/stock_delete-16.png', '16', '16' );
                echo "\n</a>";
            }
        echo "</td>";
        echo "</tr>";
    }
    echo "</table>";
} // end of function
?>
